com.asprise.imaging.scan

## Class Device

- java.lang.Object
- - com.asprise.imaging.scan.DeviceItem
  - - com.asprise.imaging.scan.Device

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    WiaDevice

      public abstract class Device
      extends DeviceItem

  Represents a device (scanner).

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `FunctionalUnit` | `getDocumentFeeder()` Finds the first document feeder functional unit
    `abstract String` | `getDriverPath()` Driver path if available
    `abstract String` | `getDriverVersion()` Driver version if available
    `FunctionalUnit` | `getFlatbed()` Finds the first flatbed functional unit.
    `List<FunctionalUnit>` | `getFunctionalUnits()` Return list of functional units available on the device - WARN: do not modify the returned list
    `abstract String` | `getPort()` Device port (optional)
    `abstract boolean` | `isDuplexReady()` Return true if this is a document feeder AND the duplexer is enabled and ready to use.
    `abstract boolean` | `isFeedReady()` Return true if this is a document feeder AND it has a page loaded and is ready for use.
    `abstract boolean` | `isFlatReady()` Return true if this is a flatbed AND it is ready for use.
    `abstract boolean` | `isScanner()` Whether the device is a scanner.
    `List<Capability>` | `refreshDeviceTree(Device refreshedDevice, DeviceItem returnChangedFor)`
    `String` | `toString()`
    `abstract String` | `toString(boolean verbose, boolean withCapabilities)` String representation of this device.

    - ### Methods inherited from class com.asprise.imaging.scan.DeviceItem

      `close, getCapabilities, getCapability, getCapabilityCurrentValueAsLong, getCapabilityCurrentValueAsString, getCapabilityValue, getCapabilityValueAsLong, getCapabilityValueAsString, getDescription, getId, getName, isCapabilityDirty, refreshCapabilities, setCapabilityDirty, setCapabilityValue`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### refreshDeviceTree

          public List<Capability> refreshDeviceTree(Device refreshedDevice,
                                           DeviceItem returnChangedFor)

    - #### isScanner

          public abstract boolean isScanner()

      Whether the device is a scanner.

    - #### getPort

          public abstract String getPort()

      Device port (optional)

    - #### getDriverPath

          public abstract String getDriverPath()

      Driver path if available

    - #### getDriverVersion

          public abstract String getDriverVersion()

      Driver version if available

    - #### getFunctionalUnits

          public List<FunctionalUnit> getFunctionalUnits()

      Return list of functional units available on the device - WARN: do not modify the returned list

    - #### getFlatbed

          public FunctionalUnit getFlatbed()

      Finds the first flatbed functional unit.
      Returns:
        the first flatbed function unit found or `null` if none is found.

    - #### getDocumentFeeder

          public FunctionalUnit getDocumentFeeder()

      Finds the first document feeder functional unit
      Returns:
        the first document feeder functional unit or `null` if none is found.

    - #### isDuplexReady

          public abstract boolean isDuplexReady()

      Return true if this is a document feeder AND the duplexer is enabled and ready to use.

    - #### isFeedReady

          public abstract boolean isFeedReady()

      Return true if this is a document feeder AND it has a page loaded and is ready for use.

    - #### isFlatReady

          public abstract boolean isFlatReady()

      Return true if this is a flatbed AND it is ready for use.

    - #### toString

          public abstract String toString(boolean verbose,
                        boolean withCapabilities)

      String representation of this device.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © Asprise Software. All Rights Reserved. Please visit the product page at asprise.com